Smart Proxy - Bug #5995

Windows AD DHCP reservation creation fails with "The specified option does not exist"
05/30/2014 07:11 AM - Oliver Weinmann

Status: Duplicate
Priority: High
Assignee:

Category: DHCP
Target version:

Difficulty: Fixed in Releases:

Triaged: Found in Releases: 1.5.0
Bugzilla link: Red Hat JIRA:

Pull request:

Description
Hi,
| upgraded from 1.3x to 1.5 two days ago and now I'm no longer able to create new hosts. :(

| always get an error during DHCP creation. Strange, because the DHCP reservation is created. We run a Win2k8 R2 server as
DHCP.

| tried to use the latest foreman-proxy dev, no change. | saw a similar bug reported:

http://projects.theforeman.org/issues/5847

but the solution to this bug didn't solve my problem.

Related issues:

Related to Smart Proxy - Bug #2870: DHCP reservations on MS DHCP servers with... Closed 08/01/2013
Related to Smart Proxy - Bug #13575: Don't fail due to missing PXEClient DHCP... Closed 02/05/2016
History

#1 - 05/30/2014 07:14 AM - Dominic Cleal
- Status changed from New to Need more information
This error message is simply reporting there's an error on your proxy server.

Please read and provide the logs from the proxy, typically "proxy.log".

#2 - 05/30/2014 07:39 AM - Oliver Weinmann
Hi,

I looked in the logs and found this:

D, [2014-05-30T09:06:22.129142 #2620] DEBUG —- : Added test.a.space.corp (172.28.7.172 / 00:50:56:b7:0d:3f) to
172.28.4.0/255.255.252.0
D, [2014-05-30T09:06:22.129142 #2620] DEBUG -- : executing: c:\windows\sysnativel\cmd.exe /c c:\Windows\System3

2\netsh.exe -c dhcp server 172.28.4.12 scope 172.28.4.0 add reservedip 172.28.7.172 005056b70d3f test.a.space.
corp

I, [2014-05-30T09:06:22.534752 #2620] INFO -- : Added DHCP reservation for test.a.space.corp (172.28.7.172 /
00:50:56:b7:0d:3f)

D, [2014-05-30T09:06:22.534752 #2620] DEBUG -- : key: "nextServer"

D, [2014-05-30T09:06:22.534752 #2620] DEBUG -- : executing: c:\windows\sysnativelcmd.exe /c c:\Windows\System3

2\netsh.exe -c dhcp server 172.28.4.12 scope 172.28.4.0 set reservedoptionvalue 172.28.7.172 66 String "172.28
.7.168"

D, [2014-05-30T09:06:22.815559 #2620] DEBUG -- : key: "PXEClient"

D, [2014-05-30T09:06:22.815559 #2620] DEBUG —- : executing: c:\windows\sysnative\cmd.exe /c c:\Windows\System3
2\netsh.exe -c dhcp server 172.28.4.12 scope 172.28.4.0 set reservedoptionvalue 172.28.7.172 60 String ""

I, [2014-05-30T09:06:23.096367 #2620] INFO -- : Vendor class not found

E, [2014-05-30T09:06:23.096367 #2620] ERROR —-- : Netsh failed:
Changed the current scope context to 172.28.4.0 scope.

The specified option does not exist.

E

D, [2014-05-30T09:06:23.096367 #2620] DEBUG -
./bin/../lib/proxy/dhcp/server/native_ms.rb:193:in " execute'
./bin/../lib/proxy/dhcp/server/native_ms.rb:54:in "addRecord'
./bin/../lib/proxy/dhcp/server/native_ms.rb:41:in “each'
./bin/../lib/proxy/dhcp/server/native_ms.rb:41:in ~addRecord'
./bin/../lib/dhcp_api.rb:94:in “POST /dhcp/:network'
:/Rubyl187/1ib/ruby/gems/1.8/gems/sinatra-1.1.0/1ib/sinatra/base.rb:1032:in
:/Rubyl87/1ib/ruby/gems/1.8/gems/sinatra-1.1.0/1lib/sinatra/base.rb:
:/Rubyl187/1lib/ruby/gems/1.8/gems/sinatra-1.1.0/1ib/sinatra/base.rb:620:1in
:/Rubyl187/1ib/ruby/gems/1.8/gems/sinatra-1.1.0/1ib/sinatra/base.rb:620:in
:/Rubyl87/1ib/ruby/gems/1.8/gems/sinatra-1.1.0/1lib/sinatra/base.rb:604:1in
:/Rubyl187/1lib/ruby/gems/1.8/gems/sinatra-1.1.0/1ib/sinatra/base.rb:656:1in
:/Rubyl187/1ib/ruby/gems/1.8/gems/sinatra-1.1.0/1ib/sinatra/base.rb:653:in
:/Rubyl87/1ib/ruby/gems/1.8/gems/sinatra-1.1.0/1lib/sinatra/base.rb:653:1in
:/Rubyl187/1lib/ruby/gems/1.8/gems/sinatra-1.1.0/1ib/sinatra/base.rb:603:1in
:/Rubyl187/1ib/ruby/gems/1.8/gems/sinatra-1.1.0/1ib/sinatra/base.rb:602:in
:/Rubyl87/1ib/ruby/gems/1.8/gems/sinatra-1.1.0/1lib/sinatra/base.rb:602:1in
:/Rubyl187/1lib/ruby/gems/1.8/gems/sinatra-1.1.0/1ib/sinatra/base.rb:741:in
:/Rubyl187/1ib/ruby/gems/1.8/gems/sinatra-1.1.0/1ib/sinatra/base.rb:530:in
:/Rubyl87/1ib/ruby/gems/1.8/gems/sinatra-1.1.0/1lib/sinatra/base.rb:706:1in
:/Rubyl187/1lib/ruby/gems/1.8/gems/sinatra-1.1.0/1ib/sinatra/base.rb:706:1in
:/Rubyl187/1ib/ruby/gems/1.8/gems/sinatra-1.1.0/1ib/sinatra/base.rb:706:in
:/Rubyl87/1ib/ruby/gems/1.8/gems/sinatra-1.1.0/1lib/sinatra/base.rb:706:1in
:/Rubyl187/1lib/ruby/gems/1.8/gems/sinatra-1.1.0/1ib/sinatra/base.rb:530:1in
:/Rubyl187/1ib/ruby/gems/1.8/gems/sinatra-1.1.0/1ib/sinatra/base.rb:516:in
:/Rubyl87/1ib/ruby/gems/1.8/gems/rack-1.2.0/1lib/rack/methodoverride.rb:24:
:/Rubyl187/1lib/ruby/gems/1.8/gems/rack-1.2.0/1ib/rack/showexceptions.rb:24:

QOO0 a0a000a0000a0000a000000000000000000a000n

, [2014-05-30T09:06:23.096367 #2620]

:/Rubyl187/1ib/ruby/gems/1.
:/Rubyl87/1ib/ruby/gems/1.
:/Rubyl187/1ib/ruby/gems/1.
:/Rubyl187/1ib/ruby/gems/1.
:/Rubyl87/1ib/ruby/gems/1.
:/Rubyl187/1ib/ruby/gems/1.

ERROR

— : Unknown error while processing ''
- : ./bin/../lib/proxy/dhcp/server/native_ms.rb:221:in

‘call!

1032:in “compile!'

8/gems/rack-1.2.0/1lib/rack/commonlogger.rb:18:1in
8/gems/sinatra-1.1.0/1lib/sinatra/base.rb:1142:1in
8/gems/sinatra-1.1.0/1lib/sinatra/base.rb:1168:1in
8/gems/sinatra-1.1.0/lib/sinatra/base.rb:1142:in
0/lib/rack/content_length.rb:13:
0/lib/rack/handler/webrick.rb:52

8/gems/rack-1.2.
8/gems/rack-1.2.

:/Rubyl87/1ib/ruby/1.
:/Rubyl187/1ib/ruby/1.
:/Rubyl187/1ib/ruby/1.
:/Rubyl87/1ib/ruby/1.
:/Rubyl187/1ib/ruby/1.
:/Rubyl187/1ib/ruby/1.
:/Rubyl87/1ib/ruby/1.
:/Rubyl187/1ib/ruby/1.
:/Rubyl187/1ib/ruby/1.
:/Rubyl87/1ib/ruby/1.

8/webrick/httpserver.
8/webrick/httpserver.
8/webrick/server.rb:
8/webrick/server.rb:
rb:
rb:
rb:
rb:
rb:
rb:

8/webrick/server.
8/webrick/server.
8/webrick/server.

95:
©28
92:
23:
82:

8/webrick/server.
8/webrick/server.
8/webrick/server.

rb:
rb:
173:
162:
162:

:/Rubyl187/1ib/ruby/gems/1.8/gems/rack-1.2.0/1lib/rack/handler/webrick.rb:13:in

./bin/../lib/sinatra-patch.rb:42:in “run!'

b

in/smart-proxy:44

#3 - 06/02/2014 08:28 AM - Oliver Weinmann

104:in "“service'
65:
in

in “run'
‘start_thread'
“start!
‘start_thread’

‘start!

in
in
in
in “each'
‘start!

‘start!

in
in

in “start'

“instance_eval'
‘route_eval'
“route!'
‘process_route'
“catch'
‘process_route'
“route!'
“each'
“route!'
“dispatch!’
calll!
“instance_eval'
“invoke'
“catch'
“invoke'
‘calll!
“call!
‘call!
in “call'
“call!
“call!
“synchronize'
“call!
in “call’

in

:in “service'

“run'

Problem also occurs on a second proxy where we only have one subnet. :( | thought maybe it's a timeout issue due too many subnets.

#4 - 06/06/2014 02:41 PM - Oliver Weinmann
Hi Guys,

“report'

this is really becoming urgent as | can't deploy any new hosts, neither can | change / update existing hosts that are managed through foreman. |
provided the logs output. Is any more info required? If yes, please let me know.

Best Regards,
Oliver

#5 - 06/06/2014 02:56 PM - Dominic Cleal

- Status changed from Need more information to New

We generally don't actively maintain AD support, so any help to track it down and submit patches would be welcomed.

My only hunch looking at that error is that it's trying to add an option for code 60.. which was added back in 1.4.0 with this commit:
https:/github.com/theforeman/smart-proxy/commit/296617a
I'd try reverting that on your installation to see if it's causing the problem. Perhaps it's only available on certain versions of AD.
#6 - 06/12/2014 08:43 AM - Oliver Weinmann
Hi Dominic,

must have missed the email about your update on this ticket. Thanks a lot the fix works. | have updated the ticket
http://projects.theforeman.org/issues/2870 about this problem. Maybe the author can provide a workaround for it.

Best Regards,
Oliver

#7 - 06/12/2014 01:32 PM - Dominic Cleal
- Related to Bug #2870: DHCP reservations on MS DHCP servers with PXEClient defined added

#8 - 07/02/2014 06:36 AM - Dominic Cleal

- Subject changed from error: ERF12-6899 [ProxyAPI::ProxyException]: Unable to set DHCP entry ([RestClient::BadRequest]: 400 Bad Request) for
proxy to Windows AD DHCP reservation creation fails with "The specified option does not exist"

#9 - 10/23/2014 08:03 AM - Sam Zandbergen

I ran into the same problem, but also had a different one. The following error:
http://pastebin.com/ib7nyxug

My problem was solved by disabling UAC and restarting the server, | was test running it in a command prompt instead of a service.

#10 - 09/23/2015 06:09 AM - Dominic Cleal
- Project changed from Foreman to Smart Proxy

- Category changed from DHCP to DHCP

#11 - 02/29/2016 09:44 AM - Anonymous
- Related to Bug #13575: Don't fail due to missing PXEClient DHCP opt on 2008R2 added

#12 - 02/29/2016 09:45 AM - Anonymous

- Status changed from New to Closed

Closing this in favour of http:/projects.theforeman.org/issues/13575, where changes for the fix are being tracked.

#13 - 02/29/2016 09:46 AM - Dominic Cleal

- Status changed from Closed to Duplicate
